%%
% ********************************************************************
% Course Homework
%               2.29: Numerical Fluid Mechanincs, Spring 2007
% Problem Set #3, Problem #1
% 04/10/07
% ********************************************************************
% Reza Karimi:
%                            Graduate Student
%                    Mechanical Engineering Department
%                  Massachusetts Institute of Technology
% Email:  rkarimi@mit.edu
% Office: NE47-319, 500 Technology Square, Cambridge, MA 02139
% Phone: (617) 324-7605
% ********************************************************************

close all, clear all,clc

A=[1 2 -1;2 8 0;-1 0 4];
b=[0 8 4]';

x0=[0 0 0]';
x=x0;
r=-A*x0+b;
v=r;
for i=0:12
    fprintf('\n\t x%d''=',i), fprintf('%f ',x')
    fprintf('\n\t r%d''=',i), fprintf('%4.5e  ',r')
    fprintf('\n\t v%d''=',i), fprintf('%f ',v')
    s=(v'*A*v);
    alpha=v'*r/s;

    x=x+alpha*v;
    r=r-alpha*A*v;
    beta=-v'*A*r/s;
    v=r+beta*v;
    fprintf('\n\t alpha%d''=',i), fprintf('%f ',alpha)
    fprintf('\n\t beta%d''=',i), fprintf('%f ',beta)
    fprintf('\n')
end